#!/usr/bin/ruby

require "aws-sdk-v1"
require 'socket'

volume = ARGV[0] or raise "Must pass EBS volume to attach.\n"
device = ARGV[1] or raise "Must pass device name to attach as.\n"

ip = UDPSocket.open {|s| s.connect('64.233.187.99', 1); s.addr.last}

ec2 = AWS::EC2.new()
AWS.memoize()
  instance_id  = String.new
  ec2.instances.each do |instance|
    if instance.private_ip_address == ip
      instance_id = instance.id
    end
  end

if instance_id.length == 0
        raise "Could not get instance id."
end

vol = ec2.volumes[ volume ]

unless vol.status == :available
        raise "Volume #{vol} not in available state\n"
end

begin
        status = vol.attach_to( ec2.instances[ instance_id ], "/dev/#{device}")
rescue
        ap $!
        raise "We received some failure doing the attachment"
end

counter = 0
while ( status.exists? && status.status != :attached )
        counter = counter + 1
        if counter == 80
                raise "Failed to attach volume"
        end
        sleep 10
end

output = `e2label /dev/xvdm`
unless $?.success? then
        `mkfs.ext4 /dev/xvdm`
end

exit 0

